/* asm9830: a portable cross-assembler for the HP 9830A/B calculator */
/* Copyright (c) 2013-2014, Robert Ferguson (rob@bitscience.ca) */
/* All rights reserved; see LICENSE for details */

#include "hash.h"
#include "symbol.h"
#include "instruction.h"
#include "opcode.h"
#include "expression.h"
#include "generate.h"

#define DEFAULT_ORIGIN	02000
#define DEFAULT_BINOUT	"a.out.o98"
#define DEFAULT_XNSOUT	"a.out.f98"

void yyerror(YYLTYPE *llocp, Program *pgm, const char *msg, ...);
void warning(YYLTYPE *llocp, char const *msg, ...);
void error(char *s, ...);

extern int verbose;
extern int warnings;
extern int listing;
extern int literal;

#define FMT_HEADER 	0x1
#define FMT_XNS		0x2
