/* asm9830: a portable cross-assembler for the HP 9830A/B calculator */
/* Copyright (c) 2013-2014, Robert Ferguson (rob@bitscience.ca) */
/* All rights reserved; see LICENSE for details */

typedef struct _entry {
	char *key;
	void *data;
	struct _entry *next;
} _Entry;

typedef struct _bucket {
	int count;
	_Entry *list;
} _Bucket;

typedef struct _htable {
	int	n;
	_Bucket *array;
} HTable;

extern HTable 	*createht(int n);
extern void  	 destroyht(HTable *ht, int flag);
extern void 	*insertht(HTable *ht, char *key, void *ptr);
extern void 	*deleteht(HTable *ht, char *key);
extern void 	*findht(HTable *ht, char *key);
extern void	*enumht(HTable *ht, char **key, void **context);
extern int	countht(HTable *ht);
