/* asm9830: a portable cross-assembler for the HP 9830A/B calculator */
/* Copyright (c) 2013-2014, Robert Ferguson (rob@bitscience.ca) */
/* All rights reserved; see LICENSE for details */

/* file header for HP9830 executables; union allows same structure for tape and object files. */

typedef union {
	unsigned short data[13];
	struct {
		union {
			unsigned short fileid;
			unsigned short magic;
		};
		unsigned short cursz;
		unsigned short ftype;
		unsigned short maxsz;
		unsigned short firstl;
		unsigned short lastl;
		unsigned short com;
		unsigned short unused[5];
		unsigned short hsum;
	};
} HP9830Header;


/* 9830 file types */

#define HP9830_FT_UNUSED	0
#define HP9830_FT_BINARY	1
#define HP9830_FT_DATA		2
#define	HP9830_FT_PROGRAM	3
#define HP9830_FT_KEY		4
#define HP9830_FT_PROTECTED	20

/* magic number used for object files */

#define HP9830_MAGIC	0x9830
