/* asm9830: a portable cross-assembler for the HP 9830A/B calculator */
/* Copyright (c) 2013-2014, Robert Ferguson (rob@bitscience.ca) */
/* All rights reserved; see LICENSE for details */

struct _inst {
	YYLTYPE loc;
	int address;
	int opcode;
	int opreg;
	int argreg;
	Expr *argument;
	int modifier;
	struct _inst *next;
};

struct _program {
	Inst *p;
	Inst *last;
	Inst *queue;
	int dot;
	int count;
	STable *st;
};

extern Inst *queueinst(Program *pgm, YYLTYPE loc, int opcode, int opreg, int argreg, Expr *arg, int mod);
extern void commitinst(Program *pgm);
extern void abortinst(Program *pgm);
extern void dumpinst(Inst *i);

extern void dumppgm(Program *pgm);
extern int checkmod(YYLTYPE loc, int arg, int mod);

