/* asm9830: a portable cross-assembler for the HP 9830A/B calculator */
/* Copyright (c) 2013-2014, Robert Ferguson (rob@bitscience.ca) */
/* All rights reserved; see LICENSE for details */

/* ids for instructions and indices into the opbits[] array */

/* Memory Reference Group: */

#define OPCODE_ADR	0 
#define OPCODE_CPR	1
#define OPCODE_LDR 	2
#define OPCODE_STR 	3
#define OPCODE_IOR 	4
#define OPCODE_ISZ 	5
#define OPCODE_AND 	6
#define OPCODE_DSZ 	7
#define OPCODE_JSM	8 
#define OPCODE_JMP 	9

/* D/I Reference Group: */

#define OPCODE_ADRg 	10
#define OPCODE_CPRg 	11
#define OPCODE_LDRg 	12
#define OPCODE_STRg 	13
#define OPCODE_IORg 	14
#define OPCODE_ISZg 	15
#define OPCODE_ANDg 	16
#define OPCODE_DSZg 	17
#define OPCODE_JSMg 	18
#define OPCODE_JMPg 	19
#define OPCODE_EXR 	20
#define OPCODE_DMA 	21
#define OPCODE_CMR 	22
#define OPCODE_TCR 	23

/* Shift-Rotate Group: */

#define OPCODE_ARR 	24
#define OPCODE_SRR 	25
#define OPCODE_SRL 	26
#define OPCODE_RRR 	27

/* Alter-Skip Group: */

#define OPCODE_SZR 	28
#define OPCODE_RZR 	29
#define OPCODE_SIR 	30
#define OPCODE_RIR 	31
#define OPCODE_SLR 	32
#define OPCODE_SRM 	33
#define OPCODE_SRP 	34
#define OPCODE_SES 	35
#define OPCODE_SEC 	36

/* Input/Output Group: */

#define OPCODE_STF 	37
#define OPCODE_CLF 	38
#define OPCODE_SFC 	39
#define OPCODE_SFS 	40
#define OPCODE_CLC 	41
#define OPCODE_STC 	42
#define OPCODE_OTR 	43
#define OPCODE_LIR 	44
#define OPCODE_MIR 	45

/* MAC Group: */

#define OPCODE_RET	46 
#define OPCODE_MOV 	47
#define OPCODE_CLR 	48
#define OPCODE_XFR 	49
#define OPCODE_MRX 	50
#define OPCODE_MRY 	51
#define OPCODE_MLS 	52
#define OPCODE_DRS 	53
#define OPCODE_DLS 	54
#define OPCODE_FXA 	55
#define OPCODE_FMP 	56
#define OPCODE_FDV 	57
#define OPCODE_CMX 	58
#define OPCODE_CMY 	59
#define OPCODE_MDI 	60
#define OPCODE_NRM 	61

/* pseduo-ops; no entries in opbits table */

#define OPCODE_DATA	62
#define OPCODE_ORG	63

/* modifiers */
/* MOD_CURRENT is implicit in the address during assembly */

#define MOD_INDIRECT	0x1
#define MOD_CURRENT	0x2 
#define MOD_SET		0x4
#define MOD_CLEAR	0x8
