/* asm9830: a portable cross-assembler for the HP 9830A/B calculator */
/* Copyright (c) 2013-2014, Robert Ferguson (rob@bitscience.ca) */
/* All rights reserved; see LICENSE for details */

typedef struct _symbol {
	int 	type;
	int	value;
	YYLTYPE	loc;
} Symbol;

#define SYMBOL_FORWARD	0x1
#define SYMBOL_DEFINED	0x2

#define SYMBOL_FOLLOW 	0x1
#define SYMBOL_NOFOLLOW 0x2

struct _stable {
	struct _stable *parent;
	HTable 	*table;
};

typedef struct _stable STable;

extern STable *createst(STable *parent);
extern void listst(STable *st, FILE *fp);
extern void destroyst(STable *st);

extern Symbol *addsymbol(STable *st, char *name, Symbol *existing, YYLTYPE *locp);
extern Symbol *delsymbol(STable *st, char *name);
extern Symbol *findsymbol(STable *st, char *name, int follow);
extern Symbol *setsymbol(STable *st, char *name, int value);
